"{ Package: 'stx:goodies/petitparser' }"

PPParser subclass:#PPDelegateParser
	instanceVariableNames:'parser'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitParser-Parsers'
!

PPDelegateParser comment:'A parser that delegates to another parser.
Instance Variables:
	parser  <PPParser>      The parser to delegate to.'
!


!PPDelegateParser class methodsFor:'instance creation'!

on: aParser
	^ self new setParser: aParser
! !

!PPDelegateParser methodsFor:'accessing'!

children
	^ Array with: parser
! !

!PPDelegateParser methodsFor:'initialization'!

setParser: aParser
	parser := aParser
! !

!PPDelegateParser methodsFor:'parsing'!

parseOn: aStream
	^ parser parseOn: aStream
! !

!PPDelegateParser class methodsFor:'documentation'!

version_SVN
    ^ '$Id: PPDelegateParser.st,v 1.2 2012-01-13 11:22:50 cg Exp $'
! !
